Grantlee: Grantlee::Engine Class Reference

Grantlee 5.2.0

Public Member Functions | List of all members
Grantlee::Engine Class Reference

Grantlee::Engine is the main entry point for creating Grantlee Templates. More...

`#include <grantlee/engine.h>`

Inheritance diagram for Grantlee::Engine:
[legend]

## Public Member Functions
| Engine (QObject *parent={})
| ~Engine () override
void | addDefaultLibrary (const QString &libName)
void | addPluginPath (const QString &dir)
void | addTemplateLoader (QSharedPointer< AbstractTemplateLoader > loader)
QStringList | defaultLibraries () const
Template | loadByName (const QString &name) const
QPair< QString, QString > | mediaUri (const QString &fileName) const
Template | newTemplate (const QString &content, const QString &name) const
QStringList | pluginPaths () const
void | removeDefaultLibrary (const QString &libName)
void | removePluginPath (const QString &dir)
void | setPluginPaths (const QStringList &dirs)
void | setSmartTrimEnabled (bool enabled)
bool | smartTrimEnabled () const
QList< QSharedPointer< AbstractTemplateLoader > > | templateLoaders ()

## Detailed Description

The Grantlee::Engine is responsible for configuring and creating Template objects. In typical use, one or more AbstractTemplateLoader objects will be added to the Engine to load template objects, and plugin directories will be set to enable finding template tags and filters.

auto engine = new Engine();
auto loader = QSharedPointer<FileSystemTemplateLoader>::create();
loader->setTemplateDirs( {"/usr/share/myapp/templates"} );
engine->addTemplateLoader( loader );
engine->addPluginPath( "/usr/lib/myapp" );
auto template1 = engine->newTemplate( "Template content", "template name" );
auto template2 = engine->loadByName( "templatefile.html" );

Once it is configured, the Engine can be used to create new templates by name by loading the templates with the loadByName method, or by defining the content in the newTemplate method.

By default the builtin tags and filters distributed with Grantlee are available in all templates without using the `{% load %}` tag in the template. These pre-loaded libraries may be configured if appropriate to the application. For example, an application which defines its own tags and filters may want them to be always available, or it may be desirable to restrict the features available to template authors by removing built in libraries.

Different Engine objects can be used to create templates with differing configurations.

# Insignificant whitespace

The output of rendering a template depends on the content of the template. In some cases when generating content in which whitespace is significant, this can have undesired effects. For example, given a template to generate C++ code like:

      class MyClass {
      {# This loop creates the  #}
      {# methods in the class   #}
      {% for method in methods %}
        {% if method.hasDox %}
          {{ method.dox }}
        {% endif %}
          {{ method.signature }}
      {% endfor %}
      };

The output would have a lot of whitespace which is not necessarily wanted.

class MyClass {
void foo() const;
};

It is possible to strip insignificant whitespace by enabling the smartTrim feature with setSmartTrimEnabled. When enabled the output will not contain a newline for any line in the template which has only one token of template syntax, such as a comment, tag or variable.

class MyClass {
void foo() const;
};

Author
  Stephen Kelly steve.nosp@m.ire@.nosp@m.gmail.nosp@m..com

Definition at line 120 of file engine.h.

## Constructor & Destructor Documentation

## ◆ Engine()

Grantlee::Engine::Engine | ( | QObject * | parent = `{}` | ) |

Constructor

## ◆ ~Engine()

Grantlee::Engine::~Engine | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ addDefaultLibrary()

void Grantlee::Engine::addDefaultLibrary | ( | const QString & | libName | ) |

Adds the library named `libName` to the libraries available by default to new Templates.

## ◆ addPluginPath()

void Grantlee::Engine::addPluginPath | ( | const QString & | dir | ) |

Prepend `dir` to the list of plugin dirs.

## ◆ addTemplateLoader()

void Grantlee::Engine::addTemplateLoader | ( | QSharedPointer< AbstractTemplateLoader > | loader | ) |

Adds `loader` to the TemplateLoaders currently configured on the Engine.

## ◆ defaultLibraries()

QStringList Grantlee::Engine::defaultLibraries | ( |  | ) | const

Returns the libraries available by default to new Templates.

## ◆ loadByName()

Template Grantlee::Engine::loadByName | ( | const QString & | name | ) | const

Load the Template identified by `name`.

The Templates and plugins loaded will be determined by the Engine configuration.

## ◆ mediaUri()

QPair<QString, QString> Grantlee::Engine::mediaUri | ( | const QString & | fileName | ) | const

Returns a URI for a media item with the name `name`.

Typically this will be used for images. For example the media URI for the image `"header_logo.png"` may be `"/home/user/common/header_logo.png"` or `"/home/user/some_theme/header_logo.png"` depending on the templateLoaders configured.

This method will not usually be called by application code. To load media in a template, use the `{% media_finder %}` template tag.

## ◆ newTemplate()

Template Grantlee::Engine::newTemplate | ( | const QString & | content,
|  | const QString & | name
| ) |  | const

Create a new Template with the content `content` identified by `name`.

The secondary Templates and plugins loaded will be determined by the Engine configuration.

## ◆ pluginPaths()

QStringList Grantlee::Engine::pluginPaths | ( |  | ) | const

Returns the currently configured plugin dirs

## ◆ removeDefaultLibrary()

void Grantlee::Engine::removeDefaultLibrary | ( | const QString & | libName | ) |

Removes the library named `libName` from the libraries available by default to new Templates.

## ◆ removePluginPath()

void Grantlee::Engine::removePluginPath | ( | const QString & | dir | ) |

Removes all instances of `dir` from the list of plugin dirs.

## ◆ setPluginPaths()

void Grantlee::Engine::setPluginPaths | ( | const QStringList & | dirs | ) |

Sets the plugin dirs currently configured on the Engine to `dirs`.

Warning
  This overwrites the default paths. You normally want addPluginPath.

See also
  Finding tags and filters

## ◆ setSmartTrimEnabled()

void Grantlee::Engine::setSmartTrimEnabled | ( | bool | enabled | ) |

Sets whether the smart trim feature is enabled for newly loaded templates.

See also
  smart_trim

## ◆ smartTrimEnabled()

bool Grantlee::Engine::smartTrimEnabled | ( |  | ) | const

Returns whether the smart trim feature is enabled for newly loaded templates.

See also
  smart_trim

This is false by default.

## ◆ templateLoaders()

QList<QSharedPointer<AbstractTemplateLoader> > Grantlee::Engine::templateLoaders | ( |  | ) |

Returns the TemplateLoaders currently configured on the Engine.

Grantlee::Engine::Engine
Engine(QObject *parent={})